#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use psfp;
use Time::Local; 
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&create_frame;}
if ($q->param('fct') eq "do_repair") {&do_repair;}
if ($q->param('fct') eq "get_top") {&get_top;}

##################################################################################

sub do_repair
{

$nr = $q->param('nr');

if ($nr == 9) {&finish_repair; exit;}

#### CONNECT TO DATABASE

if ($nr > 1)
{
if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 
}

$disp_crit = "<img src=\"$web_url/working.gif\"><BR>";


if ($nr == 1)
{
$disp_crit = $disp_crit . "&nbsp; Please Wait...";
$nr++;
&print_redir_page("$disp_crit", 0, "$admin_url/admin51.cgi?fct=do_repair&nr=$nr");
}
elsif ($nr == 2)
{
$disp_crit = $disp_crit . "&nbsp; Checking & Repairing the 'links' table. Please Wait...";
$nr++;
&print_redir_page("$disp_crit", 0, "$admin_url/admin51.cgi?fct=do_repair&nr=$nr");

$sql = "REPAIR TABLE links";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";}

}
elsif ($nr == 3)
{

$disp_crit = $disp_crit . "&nbsp; Checking & Repairing the 'dirs' table. Please Wait...";
$nr++;
&print_redir_page("$disp_crit", 0, "$admin_url/admin51.cgi?fct=do_repair&nr=$nr");

$sql = "REPAIR TABLE dirs";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $cid_sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $cid_sql";}

}
elsif ($nr == 4)
{

$disp_crit = $disp_crit . "&nbsp; Checking & Repairing the 'balogs' table. Please Wait...";
$nr++;
&print_redir_page("$disp_crit", 0, "$admin_url/admin51.cgi?fct=do_repair&nr=$nr");


$sql = "REPAIR TABLE balogs";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $cid_sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $cid_sql";}
}
elsif ($nr == 5)
{

$disp_crit = $disp_crit . "&nbsp; Checking & Repairing the 'bannergrp' table. Please Wait...";
$nr++;
&print_redir_page("$disp_crit", 0, "$admin_url/admin51.cgi?fct=do_repair&nr=$nr");

$sql = "REPAIR TABLE bannergrp";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $cid_sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $cid_sql";}
}
elsif ($nr == 6)
{

$disp_crit = $disp_crit . "&nbsp; Checking & Repairing the 'banners' table. Please Wait...";
$nr++;
&print_redir_page("$disp_crit", 0, "$admin_url/admin51.cgi?fct=do_repair&nr=$nr");

$sql = "REPAIR TABLE banners";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $cid_sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $cid_sql";}
}
elsif ($nr == 7)
{

$disp_crit = $disp_crit . "&nbsp; Checking & Repairing the 'keywlog' table. Please Wait...";
$nr++;
&print_redir_page("$disp_crit", 0, "$admin_url/admin51.cgi?fct=do_repair&nr=$nr");

$sql = "REPAIR TABLE keywlog";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $cid_sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $cid_sql";}
}
elsif ($nr == 8)
{

$disp_crit = $disp_crit . "&nbsp; Checking & Repairing the 'reviews' table. Please Wait...";
$nr++;
&print_redir_page("$disp_crit", 0, "$admin_url/admin51.cgi?fct=do_repair&nr=$nr");


$sql = "REPAIR TABLE reviews";
$sth = $dbh->prepare($sql);
if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $cid_sql"; }
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $cid_sql";}
}


if ($nr > 2)
{
$sth->finish;
$dbh->disconnect; 
}


}


sub finish_repair
{

$hbox = acs::get_heading_box("$web_url/ic_dirm.gif", "Operation Complete.", qq[You may close this window.]); 

print <<END_OF_FINISH;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body topmargin="0" leftmargin="0">
$hbox
</body>
</html>


END_OF_FINISH

}





sub print_redir_page
{
 
 my ($contents2, $delay2, $redir_link2) = @_;
 
 if ($delay2 eq "") { $delay2 = 0; }

$hbox = acs::get_heading_box("$web_url/ic_dirm.gif", "Checking and Repairing if Required", qq[$contents2]); 

print <<END_OF_FT;
 
 <html>
 <head>
 <title>PowerSeek</title>
 <meta HTTP-EQUIV="REFRESH" CONTENT="1;URL=$redir_link2">
 <link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
 </head>
 <body>
 $hbox
 </body>
 </html>
END_OF_FT
 
} 




sub create_frame
{

print <<END_OF_WB;

<html>
<head>
<title>PowerSeek</title>
</head>
<frameset framespacing="0" border="false" rows="105,*" frameborder="0">
  <frame name="header" scrolling="no" noresize target="main" src="$admin_url/admin51.cgi?fct=get_top">
  <frame name="main" src="$admin_url/admin51.cgi?fct=do_repair&nr=1">
  <noframes>
  <body>
  <p>This page uses frames, but your browser doesn't support them.</p>
  </body>
  </noframes>
</frameset>
</html>

END_OF_WB


}





sub get_top
{

print <<END_OF_TP;
<html>
<head>
<title>PowerSeek</title>
</head>
<body>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="100%" bgcolor="#0000A0"><img src="$web_url/logo5.jpg"></td>
  </tr>
</table>
</body>
</html>
END_OF_TP

} 






sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

